| OpenCV 3.4.1 Open Source Computer Vision

Public Member Functions | List of all members
cv::BackgroundSubtractor Class Referenceabstract
Video Analysis » Motion Analysis

Base class for background/foreground segmentation. : More...

`#include "background_segm.hpp"`

Inheritance diagram for cv::BackgroundSubtractor:

## Public Member Functions
virtual void | apply (InputArray image, OutputArray fgmask, double learningRate=-1)=0
| Computes a foreground mask. More...
virtual void | getBackgroundImage (OutputArray backgroundImage) const =0
| Computes a background image. More...
Public Member Functions inherited from cv::Algorithm
| Algorithm ()
virtual | ~Algorithm ()
virtual void | clear ()
| Clears the algorithm state. More...
virtual bool | empty () const
| Returns true if the Algorithm is empty (e.g. in the very beginning or after unsuccessful read. More...
virtual String | getDefaultName () const
virtual void | read (const FileNode &fn)
| Reads algorithm parameters from a file storage. More...
virtual void | save (const String &filename) const
virtual void | write (FileStorage &fs) const
| Stores algorithm parameters in a file storage. More...
void | write (const Ptr< FileStorage > &fs, const String &name=String()) const
| simplified API for language bindings This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...

## Additional Inherited Members
Static Public Member Functions inherited from cv::Algorithm
template<typename _Tp >
static Ptr< _Tp > | load (const String &filename, const String &objname=String())
| Loads algorithm from the file. More...
template<typename _Tp >
static Ptr< _Tp > | loadFromString (const String &strModel, const String &objname=String())
| Loads algorithm from a String. More...
template<typename _Tp >
static Ptr< _Tp > | read (const FileNode &fn)
| Reads algorithm from the file node. More...
Protected Member Functions inherited from cv::Algorithm
void | writeFormat (FileStorage &fs) const

## Detailed Description

Base class for background/foreground segmentation. :

The class is only used to define the common interface for the whole family of background/foreground segmentation algorithms.

## Member Function Documentation

## § apply()

virtual void cv::BackgroundSubtractor::apply | ( | InputArray | image,
|  | OutputArray | fgmask,
|  | double | learningRate = `-1`
| ) |  |
| pure virtual

Python:
| fgmask | = | cv.BackgroundSubtractor.apply( | image[, fgmask[, learningRate]] | )

Computes a foreground mask.

Parameters

  image | Next video frame.
  fgmask | The output foreground mask as an 8-bit binary image.
  learningRate | The value between 0 and 1 that indicates how fast the background model is learnt. Negative parameter value makes the algorithm to use some automatically chosen learning rate. 0 means that the background model is not updated at all, 1 means that the background model is completely reinitialized from the last frame.

Implemented in cv::bgsegm::BackgroundSubtractorLSBP, cv::bgsegm::BackgroundSubtractorGSOC, cv::BackgroundSubtractorMOG2, and cv::bgsegm::BackgroundSubtractorCNT.

## § getBackgroundImage()

virtual void cv::BackgroundSubtractor::getBackgroundImage | ( | OutputArray | backgroundImage | ) | const
| pure virtual

Python:
| backgroundImage | = | cv.BackgroundSubtractor.getBackgroundImage( | [, backgroundImage] | )

Computes a background image.

Parameters

  backgroundImage | The output background image.

Note
  Sometimes the background image can be very blurry, as it contain the average background statistics.

Implemented in cv::bgsegm::BackgroundSubtractorLSBP, cv::bgsegm::BackgroundSubtractorGSOC, and cv::bgsegm::BackgroundSubtractorCNT.

The documentation for this class was generated from the following file:

- video/include/opencv2/video/background_segm.hpp